﻿
using HierarchicalObjectStructure.NamespaceDependency;
using HierarchicalObjectStructure.NamespaceDependency.PatientNs.PatientDemographicsNs.PatientAddressNs;

namespace HierarchicalObjectStructure.NamespaceDependency.Util
{
    using System;
    using System.Data;
    using System.Configuration;
    using StructureMap;
    using StructureMap.Configuration.DSL;
    using StructureMap.Configuration;
    using StructureMap.Attributes;
    using StructureMap.Pipeline;
    using HierarchicalObjectStructure.NamespaceDependency.PatientNs;
    using HierarchicalObjectStructure.NamespaceDependency.PatientNs.PatientDemographicsNs;

    public static class Bootstrapper {

        private static Container container;
        public static Container Container { get { return container; } set{ container = value;} }

        public static void ConfigureStructureMap() {
            Container = new Container(new AntenatalReportRegistry());
        }
    }

    public class AntenatalReportRegistry : Registry {

        public AntenatalReportRegistry() {
            ForRequestedType<IPatient>().TheDefaultIsConcreteType<Patient>();
            ForRequestedType<IPatientDemographics>().TheDefaultIsConcreteType<PatientDemographics>();
            ForRequestedType<IPatientAddress>().TheDefaultIsConcreteType<PatientAddress>();
            ForRequestedType<ICurrentAddress>().TheDefaultIsConcreteType<CurrentAddress>();
            ForRequestedType<IHomeAddress>().TheDefaultIsConcreteType<HomeAddress>();
        }
    }
}
