﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HierarchicalObjectStructure.NestedDependency
{
    public interface IPatient
    {
        Patient.IPatientDemographics Demographics { get; set; }
    }
    public partial class Patient: IPatient
    {
        public interface IPatientDemographics
        {
            string PatientName { get; set; }
            PatientDemographics.IPatientAddress Address { get; set; }
        }

        public Patient(IPatientDemographics demographics)
        {
            this.demographics = demographics;
        }

        private IPatientDemographics demographics;
        public IPatientDemographics Demographics
        {
            get { return demographics; }
            set { demographics = value; }
        }

        public partial class PatientDemographics:IPatientDemographics
        {
            public interface IPatientAddress
            {
                PatientAddress.IHomeAddress PatientHomeAddress { get; set; }
                PatientAddress.ICurrentAddress PatientCurrentAddress { get; set; }
            }
            
            public PatientDemographics(IPatientAddress address)
            {
                this.address = address;
            }

            public string PatientName { get; set; }

            private IPatientAddress address;
            public IPatientAddress Address
            {
                get { return address; }
                set { address = value; }
            }
            
            public partial class PatientAddress:IPatientAddress
            {
                public interface IHomeAddress
                {
                    string Address { get; set; }
                }
                public interface ICurrentAddress
                {
                    string Address { get; set; }
                }

                public PatientAddress(IHomeAddress patientHomeAddress, 
                    ICurrentAddress patientCurrentAddress)
                {
                    this.patientHomeAddress = patientHomeAddress;
                    this.patientCurrentAddress = patientCurrentAddress;
                }

                private IHomeAddress patientHomeAddress;
                public IHomeAddress PatientHomeAddress
                {
                    get { return patientHomeAddress; }
                    set { patientHomeAddress = value; }
                }

                private ICurrentAddress patientCurrentAddress;
                public ICurrentAddress PatientCurrentAddress
                {
                    get { return patientCurrentAddress; }
                    set { patientCurrentAddress = value; }
                }
                
                public partial class HomeAddress:IHomeAddress
                {
                    public string Address { get; set; }
                }
                public partial class CurrentAddress:ICurrentAddress
                {
                    public string Address { get; set; }
                }
            }
        }
    }
}
