﻿
using HierarchicalObjectStructure.NamespaceDependency;
using HierarchicalObjectStructure.NamespaceDependency.PatientNs.PatientDemographicsNs.PatientAddressNs;

namespace HierarchicalObjectStructure.NestedDependency.Util
{
    using System;
    using System.Data;
    using System.Configuration;
    using StructureMap;
    using StructureMap.Configuration.DSL;
    using StructureMap.Configuration;
    using StructureMap.Attributes;
    using StructureMap.Pipeline;

    public static class Bootstrapper {

        private static Container container;
        public static Container Container { get { return container; } set{ container = value;} }

        public static void ConfigureStructureMap() {
            Container = new Container(new AntenatalReportRegistry());
        }
    }

    public class AntenatalReportRegistry : Registry {

        public AntenatalReportRegistry() {
            ForRequestedType<IPatient>().TheDefaultIsConcreteType<Patient>();
            ForRequestedType<Patient.IPatientDemographics>().TheDefaultIsConcreteType<Patient.PatientDemographics>();
            ForRequestedType<Patient.PatientDemographics.IPatientAddress>().TheDefaultIsConcreteType<Patient.PatientDemographics.PatientAddress>();
            ForRequestedType<Patient.PatientDemographics.PatientAddress.ICurrentAddress>().TheDefaultIsConcreteType<Patient.PatientDemographics.PatientAddress.CurrentAddress>();
            ForRequestedType<Patient.PatientDemographics.PatientAddress.IHomeAddress>().TheDefaultIsConcreteType<Patient.PatientDemographics.PatientAddress.HomeAddress>();
        }
    }
}
